--------------------------------------------------------------------------------
-- Company:       CERN, BE-CO-HT
-- Engineer:      Carlos Gil Soriano
--
-- Create Date:   10:59:15 10/31/2011
-- Design Name:   
-- Module Name:   /media/BACKUP/CERN/contrib/ohwr/conv-ttl-blo/hdl/rtl/i2c_slave_wb_master/test/i2c_slave_top_tb.vhd
-- Project Name:  i2c_slave_wb_master
-- Target Device: Spartan 6
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: i2c_slave_top
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE std.textio.ALL;
USE ieee.numeric_std.ALL;
 
ENTITY i2c_slave_top_tb IS
END i2c_slave_top_tb;
 
ARCHITECTURE behavior OF i2c_slave_top_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
  COMPONENT i2c_slave_top
    PORT(
          sda_oen    : out STD_LOGIC;
          sda_i     : in  STD_LOGIC;
          sda_o     : out STD_LOGIC;
          scl_oen    : out STD_LOGIC;
          scl_i     : in  STD_LOGIC;
          scl_o     : out STD_LOGIC;
          wb_clk    : in  STD_LOGIC;
          wb_rst_i  : in  STD_LOGIC;
          wb_stb_i  : in  STD_LOGIC;
          wb_cyc_i  : in  STD_LOGIC;
          wb_sel_i  : in  STD_LOGIC;
          wb_we_i   : in  STD_LOGIC;
          wb_data_i : in  STD_LOGIC_VECTOR (31 downto 0);
          wb_data_o : out STD_LOGIC_VECTOR (31 downto 0);
          wb_addr_i : in  STD_LOGIC_VECTOR (3 downto 0);
          wb_ack_o  : out STD_LOGIC;
          wb_rty_o  : out STD_LOGIC;
          wb_err_o  : out STD_LOGIC;
          ind_wb_addr : out  STD_LOGIC;
          inst_rd     : out  STD_LOGIC;
          inst_wr     : out  STD_LOGIC
        );
  END COMPONENT;
    

   --Inputs
   signal sda_oen  : std_logic;
   signal sda_i   : std_logic := '0';
   signal sda_o   : std_logic;
   signal scl_oen  : std_logic;
   signal scl_i   : std_logic := '0';
   signal scl_o   : std_logic;

   signal wb_clk    : std_logic := '0';
   signal wb_rst_i  : std_logic := '0';
   signal wb_stb_i  : std_logic := '0';
   signal wb_cyc_i  : std_logic := '0';
   signal wb_sel_i  : std_logic := '0';
   signal wb_we_i   : std_logic := '0';
   signal wb_data_i : std_logic_vector (31 downto 0) := X"00000000";
   signal wb_data_o : std_logic_vector (31 downto 0);
   signal wb_addr_i    : std_logic_vector (3 downto 0)  := X"0";
   signal wb_ack_o  : std_logic;
   signal wb_rty_o  : std_logic;
   signal wb_err_o  : std_logic;
   signal inst_rd   : std_logic;
   signal inst_wr   : std_logic;

   -- Clock period definitions
   constant wb_clk_period : time := 50 ns;    -- @ 20 MHz
   constant scl_i_period    : time := 2500 ns;  -- @ 400 KHz

   signal PRE_value      : UNSIGNED(15 downto 0) := X"0032";
   signal VME_crate_slot : UNSIGNED(6 downto 0)  := "0001111";
   signal i2c_addr       : STD_LOGIC_VECTOR(6 downto 0) := not(std_logic_vector(VME_crate_slot));

   signal i2c_rcved_data   : STD_LOGIC_VECTOR (7 downto 0);
   constant bytes_ind_addr : STD_LOGIC_VECTOR (7 downto 6) := "10";
   constant bytes_wr_state : STD_LOGIC_VECTOR (7 downto 0) := X"06";
   constant bytes_rd_state : STD_LOGIC_VECTOR (7 downto 0) := X"04";

   constant  STA_addr  : STD_LOGIC_VECTOR(3 downto 0) := X"0";    
   constant  PRE_addr  : STD_LOGIC_VECTOR(3 downto 0) := X"1"; 
   constant  CTR0_addr : STD_LOGIC_VECTOR(3 downto 0) := X"2";
   constant  CTR1_addr : STD_LOGIC_VECTOR(3 downto 0) := X"3";   
   constant  DRXl_addr : STD_LOGIC_VECTOR(3 downto 0) := X"4";
   constant  DRXh_addr : STD_LOGIC_VECTOR(3 downto 0) := X"5";
   constant  DTX_addr  : STD_LOGIC_VECTOR(3 downto 0) := X"6";
                         
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: i2c_slave_top PORT MAP (
          sda_oen  => sda_oen,
          sda_i   => sda_i,
          sda_o   => sda_o,
          scl_oen  => scl_oen,
          scl_i   => scl_i,
          scl_o   => scl_o,
          wb_clk    => wb_clk,
          wb_rst_i  => wb_rst_i,
          wb_stb_i  => wb_stb_i,
          wb_cyc_i  => wb_cyc_i,
          wb_sel_i  => wb_sel_i,
          wb_we_i   => wb_we_i,
          wb_data_i => wb_data_i,
          wb_data_o => wb_data_o,
          wb_addr_i => wb_addr_i,
          wb_ack_o  => wb_ack_o,
          wb_rty_o  => wb_rty_o,
          wb_err_o  => wb_err_o,
          inst_rd   => inst_rd,
          inst_wr   => inst_wr
        );

   -- Clock process definitions
   wb_clk_process :process
   begin
		wb_clk <= '1';
		wait for wb_clk_period/2;
		wb_clk <= '0';
		wait for wb_clk_period/2;
   end process;
 
   scl_i_process :process
   begin
      scl_i     <= '1';
         wait for scl_i_period/2;
      scl_i     <= '0';
         wait for scl_i_period/2;
   end process;



   -- Stimulus process
   stim_proc: process
	   
      procedure init_cond is
      begin
         sda_i   <= '1';
         scl_i   <= 'Z';
      end init_cond;

	
      procedure rst is
      begin
            wait for wb_clk_period*2;
         wb_rst_i   <= '1';
            wait for wb_clk_period*2;
         wb_rst_i   <= '0';
            wait for wb_clk_period*2;
      end rst;

	
      procedure start is
      begin
         sda_i  <= '1';
            wait until rising_edge(scl_i);
            wait for scl_i_period/4;
         sda_i  <= '0';
            wait until falling_edge(scl_i);
            wait for scl_i_period/4;
      end start;


      procedure addr_send(addr : STD_LOGIC_VECTOR(6 downto 0)) is
      begin
         for i in 6 downto 0 loop
            sda_i <= addr(i);
               wait for scl_i_period;
         end loop;
      end addr_send;

		
      procedure rd_wrn_send(rd_wrn_bit: STD_LOGIC) is
      begin
         sda_i <= rd_wrn_bit;
            wait for scl_i_period;
      end rd_wrn_send;


      procedure read_ACK (ERRORmsg: STRING; OKmsg: STRING) is
      begin
            wait for scl_i_period/2;
         assert sda_o = '0' report ERRORmsg severity ERROR;
         if (sda_o = '0') then
            report OKmsg; 
         end if;
            wait for scl_i_period/2;
      end read_ACK;


      procedure write_ACK(ack_bit: STD_LOGIC) is
      begin
         sda_i <= ack_bit;
            wait for scl_i_period;
      end write_ACK;


      procedure write_SDA(inv_byte: STD_LOGIC_VECTOR (7 downto 0)) is
      begin
         for i in 0 to 7 loop
            sda_i <= inv_byte(i);
               wait for scl_i_period;
         end loop;
      end write_SDA;

      procedure read_SDA is
      begin
        for i in 0 to 7 loop
           i2c_rcved_data(i) <= sda_o;
           wait for scl_i_period;
        end loop;
        sda_i <= '0';
           wait for scl_i_period;
        sda_i <= '1';
      end read_SDA;

      procedure pause is 
      begin
         sda_i  <= '0';
            wait until rising_edge(scl_i);
            wait for scl_i_period/4;
         sda_i  <= '1';
            wait until falling_edge(scl_i);
            wait for scl_i_period/4;
      end pause;

      -------------------------------------------------------------------------
      -- STA register
      -------------------------------------------------------------------------

      procedure read_STA is
      begin 
        wait until rising_edge(wb_clk);        
        wb_addr_i  <= STA_addr;
        wb_we_i    <= '0';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone read STA not acked" severity ERROR;
      end procedure;

      procedure write_STA(data: STD_LOGIC_VECTOR(31 downto 0)) is 
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= STA_addr;
        wb_data_i  <= data;
        wb_we_i    <= '0';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_err_o = '1' report "Wishbone write STA is not signaled as error" severity ERROR;
      end procedure;

      -------------------------------------------------------------------------
      -- PRE register
      -------------------------------------------------------------------------
      
      procedure read_PRE is 
      begin
        wait until rising_edge(wb_clk);        
        wb_addr_i  <= PRE_addr;
        wb_we_i    <= '0';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone read PRE not acked" severity ERROR;
      end procedure;

      procedure write_PRE(data: STD_LOGIC_VECTOR(15 downto 0)) is 
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= PRE_addr;
        wb_data_i(15 downto 0)  <= data;
        wb_data_i(31 downto 16) <= (others => '0');
        wb_we_i    <= '1';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone write PRE not acked" severity ERROR;
      end procedure;

      -------------------------------------------------------------------------
      -- CTR0 register
      -------------------------------------------------------------------------

      procedure read_CTR0 is
      begin
        wait until rising_edge(wb_clk);        
        wb_addr_i  <= CTR0_addr;
        wb_we_i    <= '0';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone read CTR0 not acked" severity ERROR;
      end procedure;

      procedure write_CTR0(data: STD_LOGIC_VECTOR(15 downto 0)) is
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= CTR0_addr;
        wb_data_i(15 downto 0)  <= data;
        wb_data_i(31 downto 16) <= (others => '0');
        wb_we_i    <= '1';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone write CTR0 not acked" severity ERROR;
      end procedure;

      -------------------------------------------------------------------------
      -- CTR1 register
      -------------------------------------------------------------------------

      procedure read_CTR1 is 
      begin
        wait until rising_edge(wb_clk);        
        wb_addr_i  <= CTR1_addr;
        wb_we_i    <= '0';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone read CTR1 not acked" severity ERROR;
      end procedure;

      procedure write_CTR1(data: STD_LOGIC_VECTOR(15 downto 0)) is
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= CTR1_addr;
        wb_data_i(15 downto 0)  <= data;
        wb_data_i(31 downto 16) <= (others => '0');
        wb_we_i    <= '1';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone write CTR1 not acked" severity ERROR;
      end procedure;

      -------------------------------------------------------------------------
      -- DRX0, DRX1, DRX2, DRX3 agregate access registers
      -------------------------------------------------------------------------

      procedure read_DRXl(data: STD_LOGIC_VECTOR(31 downto 0)) is
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= DRXl_addr;
        wb_we_i    <= '0';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone read DRXl not acked" severity ERROR;
      end procedure;

      procedure write_DRXl(data: STD_LOGIC_VECTOR(31 downto 0)) is 
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= DRXl_addr;
        wb_data_i  <= data;
        wb_we_i    <= '1';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_err_o = '1' report "Wishbone write DRXl is not signaled as error" severity ERROR;
      end procedure;

      -------------------------------------------------------------------------
      -- DRX4, DRX5 agregate access registers
      -------------------------------------------------------------------------

      procedure read_DRXh(data: STD_LOGIC_VECTOR(31 downto 0)) is
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= DRXh_addr;
        wb_we_i    <= '0';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone read DRXh not acked" severity ERROR;
      end procedure;

      procedure write_DRXh(data: STD_LOGIC_VECTOR(31 downto 0)) is 
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= DRXh_addr;
        wb_data_i  <= data;
        wb_we_i    <= '1';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_err_o = '1' report "Wishbone write DRXh is not signaled as error" severity ERROR;
      end procedure;

      -------------------------------------------------------------------------
      -- DTX agregate register access
      -------------------------------------------------------------------------

      procedure read_DTX(data: STD_LOGIC_VECTOR(31 downto 0)) is
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= DTX_addr;
        wb_we_i    <= '0';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone read DTX not acked" severity ERROR;
      end procedure;

      procedure write_DTX(data: STD_LOGIC_VECTOR(31 downto 0)) is
      begin
        wait until rising_edge(wb_clk);
        wb_addr_i  <= DTX_addr;
        wb_data_i  <= data;
        wb_we_i    <= '1';
        wb_stb_i   <= '1';
        wb_cyc_i   <= '1';
        wait for wb_clk_period*3/2;
        wait until rising_edge(wb_clk);        
        wb_we_i    <= '0';
        wb_stb_i   <= '0';
        wb_cyc_i   <= '0';
        assert wb_ack_o = '1' report "Wishbone write DTX not acked" severity ERROR;
      end procedure;

      -------------------------------------------------------------------------
      -- Procedure for correctly setting up the i2c slave
      -------------------------------------------------------------------------

      procedure init_cfg_i2c_slave(PRE_data: STD_LOGIC_VECTOR(15 downto 0); CTR0_data : STD_LOGIC_VECTOR(15 downto 0) ; CTR1_data : STD_LOGIC_VECTOR(15 downto 0)) is
      begin
        write_CTR0(CTR0_data and X"0002");
        wait for wb_clk_period;
        write_PRE(PRE_data);
        wait for wb_clk_period;
        write_CTR0(CTR0_data and X"FF00");
        wait for wb_clk_period;
        write_CTR1(CTR1_data);
        wait for wb_clk_period;
        write_CTR0(CTR0_data); -- Enough to assert enable bit
      end procedure;
begin

-- ERROR list
----> ACK erros
--    01   Instruction byte
--    02   Internal wishbone address high byte
--    03   Internal wishbone address low byte

   wb_rst_i   <= '0';
   init_cond;
      wait for 100ns;

   ----------------------------------------------------------------------------
   -- i2c_slave_top initial configuration
   ----------------------------------------------------------------------------

   rst;
   init_cfg_i2c_slave(std_logic_vector(PRE_value), '0'&i2c_addr&bytes_ind_addr&"0000"&"01", bytes_wr_state&bytes_rd_state);


--   rst;
--   start;
--   addr_send("0101100"); --This address is inverted
--   addr_send("0101101"); --This address is bad address
--   addr_send("0000000"); --This is the general address
--   rd_wrn_send('1');
--   pause;


-------------------------------------------------------------------------------
-- Performing a write according to ELMA crate needs
-------------------------------------------------------------------------------
-- Placing a reset produces an error in scl. It should be solved
--   rst;


-------------------------------------------------------------------------------
-- Indirect i2c write
-------------------------------------------------------------------------------   
   start;
   addr_send("0001111");  -- MSB first
   rd_wrn_send('0');
       read_ACK("ACK@01:  NACK received. Sending instruction byte (i2c addres + rd_wrn bit)", "PASS -> Instruction byte ACKED");
   write_SDA(X"A5"); -- inverted MSB
      read_ACK("ACK@02:  NACK received. Sending internal wishbone address high byte", "PASS -> Internal Wishbone Address High Byte ACKED");
   write_SDA(X"5A"); -- inverted LSB
      read_ACK("ACK@03:  NACK received. Sending internal wishbone address low byte", "PASS -> Internal Wishbone Address Low Byte ACKED");
   write_SDA("10000000"); -- inverted
      read_ACK("ACK@04:  NACK received. Sending 1st byte", "PASS -> 1st data byte");
   write_SDA("10000000"); -- inverted
      read_ACK("ACK@04:  NACK received. Sending 2nd byte", "PASS -> 2nd data byte");
   write_SDA("10000000"); -- inverted
      read_ACK("ACK@04:  NACK received. Sending 3rd byte", "PASS -> 3rd data byte");
   write_SDA("10000000"); -- inverted
      read_ACK("ACK@04:  NACK received. Sending 4th byte", "PASS -> 4th data byte");
   pause;

   wait for 100*wb_clk_period;
-------------------------------------------------------------------------------
-- Indirect i2c read
-- This is divided in a write process to set the Wishbone slave and a i2c read
-------------------------------------------------------------------------------
   start;
   addr_send("0001111"); --This address is inverted in bit order
   rd_wrn_send('0');
      read_ACK("ACK@01:  NACK received. Sending instruction byte (i2c addres + rd_wrn bit)", "PASS -> Instruction byte ACKED");
   write_SDA("10100101"); -- inverted MSB
      read_ACK("ACK@02:  NACK received. Sending internal wishbone address high byte", "PASS -> Internal Wishbone Address High Byte ACKED");
   write_SDA("00000000"); -- inverted LSB
      read_ACK("ACK@03:  NACK received. Sending internal wishbone address low byte", "PASS -> Internal Wishbone Address Low Byte ACKED");
-- At this point we must prefetch the data to be sent
   write_DTX(X"DDCCBBAA"); 
   start;
   addr_send("0001111"); --This address is inverted in bit order
   rd_wrn_send('1');
      read_ACK("ACK@01:  NACK received. Sending instruction byte (i2c addres + rd_wrn bit)", "PASS -> Instruction byte ACKED");
   read_SDA;
   read_SDA;
   read_SDA;
   read_SDA;
   pause;
   -- Here we should perform a restart condition
--   start;
--   addr_send("0101100"); --This address is inverted
--   rd_wrn_send('0');
--      read_ACK("ACK@01:  NACK received. Sending instruction byte (i2c addres + rd_wrn bit)", "PASS -> Instruction byte ACKED");  

wait;
end process;

END;
